
Core - Bug # 45308

Status: Resolved Priority: Must have
Author: Andreas Wolf Category: File Abstraction Layer (FAL)
Created: 2013-02-09 Assigned To: Andreas Wolf
Updated: 2013-02-09 Due date:
TYPO3 Version: 6.0
PHP Version:
Complexity:
Is Regression:
Sprint Focus:
Subject: uid of processed file is sometimes updated during processing
Description

After a file is being (re)processed, the information about it is stored in the database again. This is done by the
ProcessedFileRepository. The repository gathers information for the update from the processed file.

For files that are not changed (i.e. used as they are), the ProcessedFile class does a fallback to the original file object. Unfortunately,
this uses the uid of the original file, as the ProcessedFile class does also do the fallback here. This leads to some random (well, not
really random) record in sys_file_processedfile being overwritten with the information of the processed file.

The fix is quite simple: The processed file class should never return the uid of the original file, but always its own one if it has been
persisted before, otherwise simply NULL.

Related issues:
related to Core - Bug # 44616: Image caching broken for im_noScaleUp = 1 Closed 2013-01-17
related to Core - Bug # 45168: Wrong image displayed in FE if not resized Resolved 2013-02-05

Associated revisions
Revision 5516c309 - 2013-02-09 12:09 - Andreas Wolf 

[BUGFIX] Processed files get corrupted when regenerated

After a file is being (re)processed, the information about it is updated
in the database by the ProcessedFileRepository. The repository gathers
information for the update from the processed file.

For unprocessed files (i.e. those where the original file should be
used), the ProcessedFile class does a fallback to the original file
object. Unfortunately, this fallback is also applied for the uid
property, which makes the repository overwrite a random record in
sys_file_processedfile. This leads to wrong images being displayed in
the frontend.

This patch makes the processed file only return its own uid.

IMPORTANT: To make sure your sys_file_processedfile data is not
corrupted, empty the table and your processed files folder (usually
fileadmin/_processed_/). This will slow down your site as all processed
files are regenerated, but afterwards all data will be correct.

Change-Id: I40685d5748a5a0fcf015c7d876a374f42154831d
Revision 91a1d0a3 - 2013-02-09 12:23 - Andreas Wolf 

[BUGFIX] Processed files get corrupted when regenerated

After a file is being (re)processed, the information about it is updated
in the database by the ProcessedFileRepository. The repository gathers
information for the update from the processed file.

For unprocessed files (i.e. those where the original file should be
used), the ProcessedFile class does a fallback to the original file
object. Unfortunately, this fallback is also applied for the uid
property, which makes the repository overwrite a random record in
sys_file_processedfile. This leads to wrong images being displayed in
the frontend.

This patch makes the processed file only return its own uid.

IMPORTANT: To make sure your sys_file_processedfile data is not
corrupted, empty the table and your processed files folder (usually
fileadmin/_processed_/). This will slow down your site as all processed
files are regenerated, but afterwards all data will be correct.

Change-Id: I40685d5748a5a0fcf015c7d876a374f42154831d
Resolves: #45308
Related: #44616 #45168
Releases: 6.1, 6.0
Reviewed-on: https://review.typo3.org/18153
Reviewed-by: Andreas Wolf
Tested-by: Andreas Wolf

History
#1 - 2013-02-09 11:00 - Andreas Wolf
- Subject changed from uid of processed file may be updated during processing to uid of processed file is sometimes updated during processing

#2 - 2013-02-09 11:08 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18145
#3 - 2013-02-09 11:10 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18145

#4 - 2013-02-09 12:22 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-0 has been pushed to the review server.
It is available at https://review.typo3.org/18153

#5 - 2013-02-09 12:30 - Anonymous
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:91a1d0a35fd6b7eedabc90b1238a8c6b0a5074f5.
